# -*- coding: utf-8 -*-
# Author: Joe YS Jaw
# Contact: joeysj@users.sourceforge.net
# Revision: $Revision: 3968 $
# Date: $Date: 2005-10-29 14:28:44 +0200 (Sat, 29 Oct 2005) $
# Copyright: This module has been placed in the public domain.

# New language mappings are welcome.  Before doing a new translation, please
# read <http://docutils.sf.net/docs/howto/i18n.html>.  Two files must be
# translated for each language: one in docutils/languages, the other in
# docutils/parsers/rst/languages.

"""
Traditional Chinese language mappings for language-dependent features of Docutils.
"""

__docformat__ = 'reStructuredText'

labels = {
      # fixed: language-dependent
      'author': u'\u4f5c\u8005', # '作者' <-- Chinese word
      'authors': u'\u4f5c\u8005\u7fa4', # '作者群',
      'organization': u'\u7d44\u7e54', # '組織',
      'address': u'\u5730\u5740', # '地址',
      'contact': u'\u9023\u7d61', # '連絡',
      'version': u'\u7248\u672c', # '版本',
      'revision': u'\u4fee\u8a02', # '修訂',
      'status': u'\u72c0\u614b', # '狀態',
      'date': u'\u65e5\u671f', # '日期',
      'copyright': u'\u7248\u6b0a', # '版權',
      'dedication': u'\u984c\u737b', # '題獻',
      'abstract': u'\u6458\u8981', # '摘要',
      'attention': u'\u6ce8\u610f\uff01', # '注意！',
      'caution': u'\u5c0f\u5fc3\uff01', # '小心！',
      'danger': u'\uff01\u5371\u96aa\uff01', # '！危險！',
      'error': u'\u932f\u8aa4', # '錯誤',
      'hint': u'\u63d0\u793a', # '提示',
      'important': u'\u91cd\u8981', # '注意！',
      'note': u'\u8a3b\u91cb', # '註釋',
      'tip': u'\u79d8\u8a23', # '秘訣',
      'warning': u'\u8b66\u544a', # '警告',
      'contents': u'\u76ee\u9304' # '目錄'
} 
"""Mapping of node class name to label text."""

bibliographic_fields = {
      # language-dependent: fixed
      'author (translation required)': 'author',
      'authors (translation required)': 'authors',
      'organization (translation required)': 'organization',
      'address (translation required)': 'address',
      'contact (translation required)': 'contact',
      'version (translation required)': 'version',
      'revision (translation required)': 'revision',
      'status (translation required)': 'status',
      'date (translation required)': 'date',
      'copyright (translation required)': 'copyright',
      'dedication (translation required)': 'dedication',
      'abstract (translation required)': 'abstract'}
"""Traditional Chinese to canonical name mapping for bibliographic fields."""

author_separators = [';', ',',
                     u'\uff1b', # '；'
                     u'\uff0c', # '，'
                     u'\u3001', # '、'
                    ]
"""List of separator strings for the 'Authors' bibliographic field. Tried in
order."""
